-- se crea la tabla pro_etapa

if not exists(select * FROM INFORMATION_SCHEMA.TABLES  where Table_Name='pro_etapa')
BEGIN
EXEC _ini_creartabla 'pro_etapa', 1
END

-- se crean los campos requeridos para esa tabla


if not exists(select * FROM INFORMATION_SCHEMA.COLUMNS  where Table_Name='pro_etapa' and column_name = 'descripcion' )
begin
alter table [pro_etapa] add [descripcion] varchar(500) NOT NULL  DEFAULT 0
end 

if not exists(select * FROM INFORMATION_SCHEMA.COLUMNS  where Table_Name='pro_etapa' and column_name = 'fechaInicioPlaneada' )
begin
alter table [pro_etapa] add [fechaInicioPlaneada] DATETIME not NULL DEFAULT 01/01/1900
end 


if not exists(select * FROM INFORMATION_SCHEMA.COLUMNS  where Table_Name='pro_etapa' and column_name = 'fechaInicioProyectada' )
begin
alter table [pro_etapa] add [fechaInicioProyectada] DATETIME  DEFAULT 01/01/1900
end 


if not exists(select * FROM INFORMATION_SCHEMA.COLUMNS  where Table_Name='pro_etapa' and column_name = 'fechaInicioReal' )
begin
alter table [pro_etapa] add [fechaInicioReal] DATETIME  DEFAULT 01/01/1900
end 


if not exists(select * FROM INFORMATION_SCHEMA.COLUMNS  where Table_Name='pro_etapa' and column_name = 'fechaFinPlaneada' )
begin
alter table [pro_etapa] add [fechaFinPlaneada] DATETIME not NULL DEFAULT 01/01/1900
end 


if not exists(select * FROM INFORMATION_SCHEMA.COLUMNS  where Table_Name='pro_etapa' and column_name = 'fechaFinProyectada' )
begin
alter table [pro_etapa] add [fechaFinProyectada] DATETIME  DEFAULT 01/01/1900
end 


if not exists(select * FROM INFORMATION_SCHEMA.COLUMNS  where Table_Name='pro_etapa' and column_name = 'fechaFinReal' )
begin
alter table [pro_etapa] add [fechaFinReal] DATETIME  DEFAULT 01/01/1900
END



if not exists(select * FROM INFORMATION_SCHEMA.COLUMNS  where Table_Name='pro_etapa' and column_name = 'orden' )
begin
alter table [pro_etapa] add [orden] INT  DEFAULT 0
END


if not exists(select * FROM INFORMATION_SCHEMA.COLUMNS  where Table_Name='pro_etapa' and column_name = 'completado' )
begin
alter table [pro_etapa] add [completado] INT  DEFAULT 0
END


if not exists(select * FROM INFORMATION_SCHEMA.COLUMNS  where Table_Name='pro_etapa' and column_name = 'porcentajePresupuesto' )
begin
alter table [pro_etapa] add [porcentajePresupuesto] FLOAT  DEFAULT 0.0
END


if not exists(select * FROM INFORMATION_SCHEMA.COLUMNS  where Table_Name='pro_etapa' and column_name = 'valorPresupuesto' )
begin
alter table [pro_etapa] add [valorPresupuesto] MONEY  DEFAULT 0.0
END


-- se registra la creacion de columnas 

IF NOT EXISTS(SELECT *FROM [_columnas] WHERE[tabla]='pro_etapa'
     AND [columna]='descripcion' AND[mostrarEnGrilla]=1 AND[ordenGrilla]=5AND[requerido]=1 AND [tipo]='varchar' AND[defecto]=0 AND [tamano] =500)
BEGIN
INSERT INTO [_columnas]
([tabla] ,[columna] ,[mostrarEnGrilla],[ordenGrilla],[requerido] ,[tipo],[defecto],[tamano])
 VALUES
 ('pro_etapa' ,'descripcion',1 ,5 ,1 ,'varchar' ,0 ,500)
END




IF NOT EXISTS(SELECT *FROM [_columnas] WHERE[tabla]='pro_etapa'
     AND [columna]='fechaInicioPlaneada' AND[mostrarEnGrilla]=1 AND[ordenGrilla]=5AND[requerido]=1 AND [tipo]='date' AND[defecto]=0 AND [tamano] =100)
BEGIN
INSERT INTO [_columnas]
([tabla] ,[columna] ,[mostrarEnGrilla],[ordenGrilla],[requerido] ,[tipo],[defecto],[tamano])
 VALUES
 ('pro_etapa' ,'fechaInicioPlaneada',1 ,5 ,1 ,'date' ,0 ,100)
END



IF NOT EXISTS(SELECT *FROM [_columnas] WHERE[tabla]='pro_etapa'
     AND [columna]='fechaInicioProyectada' AND[mostrarEnGrilla]=1 AND[ordenGrilla]=5AND[requerido]=1 AND [tipo]='date' AND[defecto]=0 AND [tamano] =100)
BEGIN
INSERT INTO [_columnas]
([tabla] ,[columna] ,[mostrarEnGrilla],[ordenGrilla],[requerido] ,[tipo],[defecto],[tamano])
 VALUES
 ('pro_etapa' ,'fechaInicioProyectada',1 ,5 ,1 ,'date' ,0 ,100)
END


IF NOT EXISTS(SELECT *FROM [_columnas] WHERE[tabla]='pro_etapa'
     AND [columna]='fechaInicioReal' AND[mostrarEnGrilla]=1 AND[ordenGrilla]=5AND[requerido]=1 AND [tipo]='date' AND[defecto]=0 AND [tamano] =100)
BEGIN
INSERT INTO [_columnas]
([tabla] ,[columna] ,[mostrarEnGrilla],[ordenGrilla],[requerido] ,[tipo],[defecto],[tamano])
 VALUES
 ('pro_etapa' ,'fechaInicioReal',1 ,5 ,1 ,'date' ,0 ,100)
END



IF NOT EXISTS(SELECT *FROM [_columnas] WHERE[tabla]='pro_etapa'
     AND [columna]='fechaFinPlaneada' AND[mostrarEnGrilla]=1 AND[ordenGrilla]=5AND[requerido]=1 AND [tipo]='date' AND[defecto]=0 AND [tamano] =100)
BEGIN
INSERT INTO [_columnas]
([tabla] ,[columna] ,[mostrarEnGrilla],[ordenGrilla],[requerido] ,[tipo],[defecto],[tamano])
 VALUES
 ('pro_etapa' ,'fechaFinPlaneada',1 ,5 ,1 ,'date' ,0 ,100)
END



IF NOT EXISTS(SELECT *FROM [_columnas] WHERE[tabla]='pro_etapa'
     AND [columna]='fechaFinProyectada' AND[mostrarEnGrilla]=1 AND[ordenGrilla]=5AND[requerido]=1 AND [tipo]='date' AND[defecto]=0 AND [tamano] =100)
BEGIN
INSERT INTO [_columnas]
([tabla] ,[columna] ,[mostrarEnGrilla],[ordenGrilla],[requerido] ,[tipo],[defecto],[tamano])
 VALUES
 ('pro_etapa' ,'fechaFinProyectada',1 ,5 ,1 ,'date' ,0 ,100)
END


IF NOT EXISTS(SELECT *FROM [_columnas] WHERE[tabla]='pro_etapa'
     AND [columna]='fechaFinReal' AND[mostrarEnGrilla]=1 AND[ordenGrilla]=5AND[requerido]=1 AND [tipo]='date' AND[defecto]=0 AND [tamano] =100)
BEGIN
INSERT INTO [_columnas]
([tabla] ,[columna] ,[mostrarEnGrilla],[ordenGrilla],[requerido] ,[tipo],[defecto],[tamano])
 VALUES
 ('pro_etapa' ,'fechaFinReal',1 ,5 ,1 ,'date' ,0 ,100)
END


IF NOT EXISTS(SELECT *FROM [_columnas] WHERE[tabla]='pro_etapa'
     AND [columna]='orden' AND[mostrarEnGrilla]=1 AND[ordenGrilla]=5AND[requerido]=1 AND [tipo]='int' AND[defecto]=0 AND [tamano] =100)
BEGIN
INSERT INTO [_columnas]
([tabla] ,[columna] ,[mostrarEnGrilla],[ordenGrilla],[requerido] ,[tipo],[defecto],[tamano])
 VALUES
 ('pro_etapa' ,'orden',1 ,5 ,1 ,'int' ,0 ,100)
END



IF NOT EXISTS(SELECT *FROM [_columnas] WHERE[tabla]='pro_etapa'
     AND [columna]='completado' AND[mostrarEnGrilla]=1 AND[ordenGrilla]=5AND[requerido]=1 AND [tipo]='int' AND[defecto]=0 AND [tamano] =100)
BEGIN
INSERT INTO [_columnas]
([tabla] ,[columna] ,[mostrarEnGrilla],[ordenGrilla],[requerido] ,[tipo],[defecto],[tamano])
 VALUES
 ('pro_etapa' ,'completado',1 ,5 ,1 ,'int' ,0 ,100)
END


IF NOT EXISTS(SELECT *FROM [_columnas] WHERE[tabla]='pro_etapa'
     AND [columna]='porcentajePresupuesto' AND[mostrarEnGrilla]=1 AND[ordenGrilla]=5AND[requerido]=1 AND [tipo]='float' AND[defecto]=0 AND [tamano] =100)
BEGIN
INSERT INTO [_columnas]
([tabla] ,[columna] ,[mostrarEnGrilla],[ordenGrilla],[requerido] ,[tipo],[defecto],[tamano])
 VALUES
 ('pro_etapa' ,'porcentajePresupuesto',1 ,5 ,1 ,'int' ,0 ,100)
END


IF NOT EXISTS(SELECT *FROM [_columnas] WHERE[tabla]='pro_etapa'
     AND [columna]='porcentajePresupuesto' AND[mostrarEnGrilla]=1 AND[ordenGrilla]=5AND[requerido]=1 AND [tipo]='float' AND[defecto]=0 AND [tamano] =100)
BEGIN
INSERT INTO [_columnas]
([tabla] ,[columna] ,[mostrarEnGrilla],[ordenGrilla],[requerido] ,[tipo],[defecto],[tamano])
 VALUES
 ('pro_etapa' ,'porcentajePresupuesto',1 ,5 ,1 ,'float' ,0 ,100)
END



IF NOT EXISTS(SELECT *FROM [_columnas] WHERE[tabla]='pro_etapa'
     AND [columna]='valorPresupuesto' AND[mostrarEnGrilla]=1 AND[ordenGrilla]=5AND[requerido]=1 AND [tipo]='money' AND[defecto]=0 AND [tamano] =100)
BEGIN
INSERT INTO [_columnas]
([tabla] ,[columna] ,[mostrarEnGrilla],[ordenGrilla],[requerido] ,[tipo],[defecto],[tamano])
 VALUES
 ('pro_etapa' ,'valorPresupuesto',1 ,5 ,1 ,'MONEY' ,0 ,100)
END

-- creacion de tabla auxiliar

if not exists(select * FROM INFORMATION_SCHEMA.TABLES  where Table_Name='pro_etapa')
begin
create table [pro_etapa_aux] (
uid varchar (500)
,[etapa] varchar (300)
,[etapa_codigo] varchar (100)
)
end 
